#ifndef BLOCKBORDER_H
#define BLOCKBORDER_H
#include "trainsignal.h"
#include "block.h"
#include <QJsonObject>

class Block;
class Layout;

class BlockBorder
{
private:
	uint64_t reader_;
	uint32_t id_;
	std::vector<std::pair<uint32_t, bool>> signalIds_;
	std::vector<std::weak_ptr<Signal>> signals_;
	std::vector<bool> signalDirections_;
	std::pair<std::weak_ptr<Block>, std::weak_ptr<Block>> blocks_;

	static void setSignal(std::weak_ptr<Signal> signalWeak, int8_t value);

public:
	BlockBorder(uint8_t reader = 0, std::pair<std::weak_ptr<Block>, std::weak_ptr<Block>> blocks = std::pair<std::weak_ptr<Block>, std::weak_ptr<Block>>(), uint32_t id = QRandomGenerator::global()->generate());
	bool isReader(uint8_t reader);
	uint8_t getReader();
	void updateSignals();
	std::shared_ptr<Block> getOtherBlock(Block* block);
	std::pair<std::weak_ptr<Block>, std::weak_ptr<Block>> getBlocks(){return blocks_;}
	void setBlocks(std::pair<std::weak_ptr<Block>, std::weak_ptr<Block>> blocks){blocks_ = blocks;}
	void addSignal(std::weak_ptr<Signal> signal, std::shared_ptr<Block> block);
	void informOfSignal(std::shared_ptr<Signal> signal);
	std::shared_ptr<Block> getOverlap(BlockBorder* border);
	uint32_t id() {return id_;}
	void store(QJsonObject& json);
	void load(const QJsonObject& json);
};

#endif // BLOCKBORDER_H
