#include "overlorditemstore.h"
#include <QDebug>
#include "train.h"

OverlordItemStore::OverlordItemStore(QObject *parent): ItemStore(parent)
{
}

void OverlordItemStore::gotNfcTag(NfcUid uid)
{
	for(std::shared_ptr<Item> item : items_)
	{
		std::shared_ptr<Train> train = std::dynamic_pointer_cast<Train>(item);
		if(!train)
			continue;
		int owns = train->ownsTag(uid);
		if(owns == Train::TAG_FRONT || owns == Train::TAG_BACK)
		{
			qDebug()<<"Train"<<train->getTrainId()<<"arrived at reader"<<uid.reader;
			trainArrivedAtReader(uid.reader, train, owns);
			return;
		}
	}
}
